package com.ankaibei.workFlow.webadmin.upms.dao;

import com.ankaibei.workFlow.common.core.base.dao.BaseDaoMapper;
import com.ankaibei.workFlow.webadmin.upms.model.SysDeptPost;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 部门岗位数据操作访问接口。
 *
 * @author Buzhanyi
 * @date 2022-09-25
 */
public interface SysDeptPostMapper extends BaseDaoMapper<SysDeptPost> {

    /**
     * 获取指定部门Id的部门岗位多对多关联数据列表，以及关联的部门和岗位数据。
     *
     * @param deptId 部门Id。如果参数为空则返回全部数据。
     * @return 部门岗位多对多数据列表。
     */
    List<Map<String, String>> getSysDeptPostListWithRelationByDeptId(@Param("deptId") String deptId);

    /**
     * 获取指定部门Id的领导部门岗位列表。
     *
     * @param deptId 部门Id。
     * @return 指定部门Id的领导部门岗位列表
     */
    List<SysDeptPost> getLeaderDeptPostList(@Param("deptId") Long deptId);
}
